VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsDragDrop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Compare Text
Option Explicit

Private objForm As Object
Private objTextBox As Object

Public Property Set Form(FormIn As Object)
    Set objForm = FormIn
End Property

Public Property Set TextBox(TextBoxIn As Object)
    Set objTextBox = TextBoxIn
End Property

Public Sub SubClassHookForm()

    Call DragAcceptFiles(objForm.hWnd, 1)

    lpPrevWndProc = SetWindowLong(objForm.hWnd, _
                    GWL_WNDPROC, _
                    AddressOf WindowProc)

    Set CDrag = Me

End Sub

Public Sub SubClassUnHookForm()

    Call SetWindowLong(objForm.hWnd, _
                        GWL_WNDPROC, _
                        lpPrevWndProc)

    Call DragAcceptFiles(objForm.hWnd, 0)
    
    Set CDrag = Nothing

End Sub

Sub AcceptDroppedFiles(hDrop As Long)

Dim lngNumOfFiles As Long
Dim lngReturn As Long
Dim strFileName As String
Dim lngLoop As Long

' Get the number of dropped files

    lngNumOfFiles = DragQueryFile(hDrop, _
            GetNumOfFiles, 0&, 0)

    For lngLoop = 0 To lngNumOfFiles
' Allocate buffer for the name of the file
        strFileName = String$(257, Chr$(0))
' Get the name of the file
        lngReturn = DragQueryFile(hDrop, lngLoop, _
                strFileName, Len(strFileName))
' Add the file name to the list
        If lngReturn > 0 Then
            objTextBox.Text = objTextBox.Text & _
                Left$(strFileName, lngReturn) & vbCrLf
        End If
    Next lngLoop
' Tell Windows to free the memory allocated to store
' the dropped files
    DragFinish hDrop
    
End Sub

